#include <iostream>
#include <iomanip>
using namespace std;

void numberToDay(int);
int howManyDays(int,int);
int howMany(int, int);

int main(int argc, char** argv) {
    
    int m,y,days,startDay;
    cout << "Zadejte mesic a rok:" << endl;

    cin >> m;

    if(cin.fail() || m<1 || m>12)
    {

        cout << "Nespravny vstup." << endl;
        return(1);

    }

    cin >> y;

    if(cin.fail() || y<1753)
    {

        cout << "Nespravny vstup." << endl;
        return(1);

    }


    switch(m) {

        case 1: cout << "Leden";
            break;

        case 2: cout << "Unor";
            break;

        case 3: cout << "Brezen";
            break;

        case 4: cout << "Duben";
            break;

        case 5: cout << "Kveten";
            break;

        case 6: cout << "Cerven";
            break;

        case 7: cout << "Cervenec";
            break;

        case 8: cout << "Srpen";
            break;

        case 9: cout << "Zari";
            break;

        case 10: cout << "Rijen";
            break;

        case 11: cout << "Listopad";
            break;

        case 12: cout << "Prosinec";
            break;

    }

    cout << " " << y << endl;

   days=howMany(m,y);

   


   startDay = howManyDays(m,y); // pocitano od 1.1.1754, coz je utery
   startDay = (startDay+1)%7;

       for (int i = 0; i < 7; i++) {

        numberToDay(i);
        
        for (int j = i; (j-startDay+1) <= days; j+=7) {

            if(j<startDay) cout << "   ";
            else cout << " " << setw(2) << setfill('0') << (j-startDay+1);

        } cout << endl;


    }

    return (0);
}

int howMany(int m, int y){

        if (((m<=7 && m%2!=0) || (m>7 && m%2==0 ))) return 31;
        if ((m!=2 && m<=7 && m%2==0) || (m>7 && m%2!=0)) return 30;
        if ((m==2 && (((y%4==0 && y%100!=0)) || (y%400==0)))) return 29;
        if ((m==2 && !(((y%4==0 && y%100!=0)) || (y%400==0)) )) return 28;

        return 0;
   }

int howManyDays(int m,int y){ // since 1.1.1754 (Tuesday)

    int days=0;

    for (int i = 1754; i < y; i++) {
        if (((i%4==0 && i%100!=0)) || (i%400==0)) days +=366;
        else days +=365;
    }

    for (int i = 1;  i<m; i++) {

        if ((i==2 && (((y%4==0 && y%100!=0)) || (y%400==0)))) { days+=29; continue; }
        if ((i==2 && !(((y%4==0 && y%100!=0)) || (y%400==0)) )) { days+=28; continue; }
        if (((i<=7 && i%2!=0) || (i>7 && i%2==0 ))) { days+=31; continue; }
        if ((i!=2 && i<=7 && i%2==0) || (i>7 && i%2!=0)) { days+=30; continue; }

    }

    return days;

   }

void numberToDay(int i){

            switch(i){

            case 0: cout << "Po";
                    break;
            case 1: cout << "Ut";
                    break;
            case 2: cout << "St";
                    break;
            case 3: cout << "Ct";
                    break;
            case 4: cout << "Pa";
                    break;
            case 5: cout << "So";
                    break;
            case 6: cout << "Ne";
                    break;

        }

   cout << " ";

}
