#ifndef __PROGTEST__

#include <iostream>
#include <iomanip>
#include <fstream>
using namespace std;

bool compressRLE   ( const char * inFileName, const char * outFileName );
bool decompressRLE ( const char * inFileName, const char * outFileName );
void generate ( const char * outFileName);

int main ( int argc, char * argv [] )
 {
   // generate("in.txt");
    compressRLE ("in.txt","out.txt");
    decompressRLE("out.txt","decompress.txt");
 }

void generate   ( const char * outFileName){
ofstream out;
out.open( outFileName, ios::binary | ios::out);


  // RLE begins
char i = 0x00;
    for (int d=0; d<=255; d++) {

        for (int a = 0; a < 144; a++) {
            out.put(i);
            cout << i;
        } i++;
    }

  out.close();


}

#endif /* __PROGTEST__ */

bool compressRLE   ( const char * inFileName, const char * outFileName ){

    ifstream in;
    ofstream out;

  int * buffer;
  long size;

  int ch;

    in . open ( inFileName, ios::binary | ios::in);

  // get size of file
  in.seekg(0,ifstream::end);
  size=in.tellg();
  in.seekg(0);

  // allocate memory for file content
  buffer = new int [size];

  int counter=0;
   while ( 1 )
    {
      ch = in . get ();
      if ( in . eof () ) break;
      if ( in . fail () )
       {
         in . close ();
         return ( false );
       }

      buffer[counter++]=ch;
     }
  //cout << "counter>" << counter << endl;

  in.close();

  out.open( outFileName, ios::binary | ios::out);


  // RLE begins
    for (int i = 0; i < counter; i++) {

        int nalezu=1;
        while((buffer[i] == buffer[i+nalezu]) && nalezu<=62) {
            nalezu++;
        }
        //cout << buffer[i] << endl;

        // if(i!=0) cout << " ";

      if (nalezu <= 2 && buffer[i] < 0xC0) {
          out.put(buffer[i]);
          if(out.bad()==true) return false;
         // cout << hex << setw(2) << setfill('0') << buffer[i];

          if(nalezu==2) {
              out.put(buffer[i]);
              if(out.bad()==true) return false;
            //  cout << hex << setw(2) << setfill('0') << buffer[i];
          }
          }

      if (nalezu <= 2 && buffer[i] >= 0xC0) {
          out.put((0xc0+nalezu)); out.put(buffer[i]);
           if(out.bad()==true) return false;
         // cout << "c" << nalezu << " " << hex << setw(2) << setfill('0') << buffer[i];
      }

      if (nalezu >2) {
          out.put((0xc0 + nalezu)); out.put(buffer[i]);
          if(out.bad()==true) return false;
          //cout << hex << setw(2) << setfill('0') << (0xc0 | nalezu) << " " << buffer[i];
      }

        i=i+nalezu-1;
        //cout << i;

    }

   // cout << endl;


  // release dynamically-allocated memory
  delete[] buffer;
  out.close();
  return true;

}

bool decompressRLE ( const char * inFileName, const char * outFileName ){

    ifstream in;
    ofstream out;

  int * buffer;
  long size;

  int ch;

    in . open ( inFileName, ios::binary | ios::in);

  // get size of file
  in.seekg(0,ifstream::end);
  size=in.tellg();
  in.seekg(0);

  // allocate memory for file content
  buffer = new int [size];

  int counter=0;
   while ( 1 )
    {
      ch = in . get ();
      if ( in . eof () ) break;
      if ( in . fail () )
       {
         cout << "Chyba cteni souboru" << endl;
         in . close ();
         return ( false );
       }

      buffer[counter++]=ch;
     }

  in.close();

  out.open( outFileName, ios::binary | ios::out);


  // uncompres RLE begins
    for (int i = 0; i < counter; i++) {

        //if(i!=0) cout << " ";

      if (buffer[i] < 0xC0) {
          out.put(buffer[i]);
          if(out.bad()==true) return false;
          //cout << hex << setw(2) << setfill('0') << buffer[i];
          }

      if (buffer[i] >= 0xC0) {

          for (int a = 0; a < (buffer[i] & 0x3f); a++) {

            out.put(buffer[i+1]);
            if(out.bad()==true) return false;
            //cout << hex << setw(2) << setfill('0') << buffer[i+1];

            } i++;

      }
    }

   // cout << endl;


  // release dynamically-allocated memory
  delete[] buffer;
  out.close();
  return true;

}
