#include <iostream>
#include <sstream>
#include <string>
#include <iomanip>

using namespace std;

double ** allocMatrix ( int rows, int cols );
void printMatrix ( double ** mat, int rows, int cols );
void freeMatrix ( double ** mat, int rows );
double ** horniTroj(double ** mat, int size);

int main(int argc, char** argv) {

    int count=0;
    char buff[512];
    cin.getline(buff,512);

    istringstream data(buff);

    string rd;
    getline(data,rd);

    string rd_first = rd;
    double hlp;
    istringstream first(rd_first);

    while (first >> hlp) { // find out, how big the matrix will be
        count++;
    }

    if(count == 0) {

        cout << "Nespravny vstup." << endl;
        return (0);

    }

    double ** mat = allocMatrix(count,count);

    int lines=0,cols=0;
    do{ // projde radky
        cols=0;
       istringstream line(buff); //rd

            if(lines==count) { // pokus o vytvoreni vice radku

                freeMatrix(mat,count);
                cout << "Nespravny vstup." << endl;
                return (0);

            }

        while(line >> hlp) {

            if(cols>=count) { // na radku je vice prvku nez ma byt

                freeMatrix(mat,count);
                cout << "Nespravny vstup." << endl;
                return (0);

            }

        mat[lines][cols++]=hlp;

        }
        lines++;
            if(cols!=count) { // na radku je mene prvku nez ma byt

                freeMatrix(mat,count);
                cout << "Nespravny vstup." << endl;
                return (0);

            }

    } while(cin.getline(buff,512));
    //while(getline(data,rd));

                if(lines!=count) { // je mene radku nez ma byt

                freeMatrix(mat,count);
                cout << "Nespravny vstup." << endl;
                return (0);

            }

   // printMatrix(mat,count,count);
    //matice nactena
    //cout << endl;
    mat=horniTroj(mat,count);
    //printMatrix(mat,count,count);
   // cout << endl;

            double determinant=1;
            for (int i = 0; i < count; i++) {
            determinant=determinant*mat[i][i];
        } cout << "Determinant: " << fixed << setprecision(6) << determinant << endl;


 
    freeMatrix(mat,count);
    return (0);
}

    //metoda převádějící matici na horní trojúhelníkovou
    double ** horniTroj(double ** mat, int size) {
        double k;
        int ii, rr, ss;
        for (int i = size - 1; i > 0; i--) {
            ii = size - i - 1;
            for (int r = i - 1; r >= 0; r--) {
                rr = size - r - 1;
                k = -(mat[rr][ii]) / (mat[ii][ii]);
                    for (int s = i; s >= 0; s--) {
                    ss=s+ii;
                    mat[rr][ss] = mat[rr][ss] + k * mat[ii][ss];
                }
            }
        }
        return mat;
    }

double ** allocMatrix ( int rows, int cols )
{
//cout << "alocating matrix " << rows << "x" <<cols << endl;
int i;
double ** mat;
mat = new double * [ rows ];
for ( i = 0; i < rows; i ++ )
mat[i] = new double [cols];
return ( mat );
}

void printMatrix ( double ** mat, int rows, int cols )
{
int i, j;
for ( i = 0; i < rows; i ++ )
{
for ( j = 0; j < cols; j ++ )
cout << mat[i][j] << " ";
cout << endl;
}
}

void freeMatrix ( double ** mat, int rows )
{
int i;
for ( i = 0; i < rows; i ++ )
delete [] mat[i];
delete [] mat;
}
