#ifndef __PROGTEST__

#include <iostream>
using namespace std;

#endif /* __PROGTEST__ */

class CSetInt
 {
   public:
                             CSetInt                       ( void );
                            ~CSetInt                       ( void );
    bool                     Insert                        ( int X );
    bool                     Delete                        ( int X );
    bool                     IsSet                         ( int X ) const;
    int                      Size                          ( void ) const;
    void                     echoData                      ( void ) const;
    
private:
    int * data;
    int arraySize;
    int elementCount;

    void                    makeBiggerArray               ( void );

 };

 void CSetInt::makeBiggerArray(){

            arraySize*=2;
            int * data_temp = new int[arraySize]; // array 2* bigger
            
            for (int i = 0; i < elementCount; i++) { // copy elements
                data_temp[i]=data[i];
            }

            delete [] data;
            data=data_temp;
 }

 void CSetInt::echoData() const {
     cout << "vypis: ";
     for (int i = 0; i < elementCount; i++) {
         cout << data[i] << " ";
    } cout << endl;
 }
 
 bool CSetInt::Insert(int X){

     // if the array is empty, than just insert int to the beginning
     if(elementCount==0) { data[0]=X; elementCount++; return true; } else {
     
    int index=-1;
     
      /* for (int i = 0; i < elementCount; i++) {
         if(data[i]<=X) { // if smaller then inserted, do nothing, continue
            if(data[i]==X) { return false; } // if equal, break, already have this element
         } else { // if it is bigger, i have index where to put new element
             index=i;
             break;
         }
     } */

    int left = 0, right = elementCount-1;
int middle=0;

    while (left <= right) {
        middle = (right + left) / 2;

        if ( data[middle] == X )
        { index=middle; break; }
        if ( X < data[middle] )
            right = middle - 1;
        else
            left = middle + 1;
        }

if(index!=-1) return false;

index=left;

           if(elementCount==arraySize) {// increase size of the array if necessary
              this->makeBiggerArray();
          }
       
                      
        for (int i = elementCount; i >= index ; i--) { //shift all elements behind index I found
               data[i]=data[i-1];
        }


//int n= sizeof(int) * (index+1);
//int m= sizeof(int) * (index);

//cout << "uloz na pozici: " << m << "kopiruj z " << n << endl;

          // memmove(data + n , data + m,elementCount-index);
           data[index]=X; //insert the element !
           elementCount++; // increase number of elements

       

       return true;
    }
 }

 bool CSetInt::Delete(int X){
     int index=-1;

     for (int i = 0; i < elementCount; i++)
         if(data[i]==X) { index=i; break; }

     if(index==-1) return false;

     else { // element is in the array, lets shift all elements behind one field back

         for (int i = index+1; i < elementCount; i++)
             data[i-1]=data[i];

         elementCount--;
         return true;

     }

 }
 
 int CSetInt::Size() const {
     return elementCount;
 }

 bool CSetInt::IsSet(int X) const { // find the element with log n complexity


int left = 0, right = elementCount-1;
int middle=0;

    while (left <= right) {
        middle = (right + left) / 2;
        
        if ( data[middle] == X )
            return true;
        if ( X < data[middle] )
            right = middle - 1;
        else
            left = middle + 1;
        }

return false;

 }

 CSetInt::CSetInt(){
     arraySize=2;
     elementCount=0;

     data =  new int[arraySize];

 }

 CSetInt::~CSetInt(){
     delete [] data;
 }

 #ifndef __PROGTEST__

int main(int argc, char** argv) {

bool status;

CSetInt  S2;
status = S2 . Insert ( 10 );
cout << status << " " << S2.Size() << endl;
S2.echoData();

// status = true, S2 . Size () => 1
status = S2 . Insert ( 20 );
cout << status << " " << S2.Size() << endl;
S2.echoData();

// status = true, S2 . Size () => 2
status = S2 . Insert ( 30 );
cout << status << " " << S2.Size() << endl;
S2.echoData();

// status = true, S2 . Size () => 3
status = S2 . IsSet  ( 30 );
cout << "je tam 30: " << status << " " << S2.Size() << endl;
S2.echoData();

status = S2 . IsSet  ( 40 );
cout << "je tam 40: " << status << " " << S2.Size() << endl;
S2.echoData();

// status = true
status = S2 . Delete ( 30 );
cout << "smaz 30: " << status << " " << S2.Size() << endl;
S2.echoData();

// status = true, S2 . Size () => 2
status = S2 . IsSet  ( 30 );
cout << "je tam 30: " << status << " " << S2.Size() << endl;
S2.echoData();

// status = false
status = S2 . Delete ( 30 );
cout << status << " " << S2.Size() << endl;
S2.echoData();

// status = false, S2 . Size () => 2
status = S2 . Insert ( 30 );
cout << status << " " << S2.Size() << endl;
S2.echoData();

// status = true, S2 . Size () => 3
status = S2 . IsSet  ( 30 );
cout << status << " " << S2.Size() << endl;
S2.echoData();
// status = true

S2.Insert(25);
S2.echoData();
S2.Insert(45);
S2.echoData();
S2.Insert(22);
S2.echoData();
S2.Insert(14);
S2.echoData();
S2.Insert(4);
S2.echoData();
S2.Insert(5);
S2.echoData();
S2.Insert(47);
S2.echoData();

    return (0);
}

#endif /* __PROGTEST__ */
